/* Auteur: Nicolas JANEY          */
/* nicolas.janey@univ-fcomte.fr   */
/* Mars 2006                      */

import java.io.*;
import java.text.*;

public class PuissanceMatrice {
  static BufferedReader flux = new BufferedReader(new InputStreamReader(System.in));
  static DecimalFormat df = new DecimalFormat("0.0000 ");

  /* Creation d'une chaine de caracteres                  */
  /* representant un nombre reel complemente par          */
  /* des espaces pour obtenir une longueur totale fixee   */
  
  public static String format(float v) {
    if ( v < 10.0F )
      return("  "+df.format(v));
      else
      if ( v < 100.0F )
        return(" "+df.format(v));
        else
        return(df.format(v));
  }
  
  /* Affichage d'une matrice de reelss formatee           */
  /* en lignes et en colonnes                             */

  public static void affichageMatrice(float [][] m) {
    for ( int i = 0 ; i < m.length ; i++ ) {
      for ( int j = 0 ; j < m[i].length ; j++ )
        System.out.print(format(m[i][j]));
      System.out.println(); }
  }
  
  /* Creation d'une matrice de reels tires au sort entre  */
  /* 0 et une valeur limite pour un nombre arbitraire     */
  /* de lignes et de colonnes                             */
  
  public static float [][] matriceAuHasard(int lignes,int colonnes,float max) {
    float [][] m = new float[lignes][colonnes];
    for ( int i = 0 ; i < lignes ; i++ )
      for ( int j = 0 ; j < colonnes ; j++ )
        m[i][j] =(float) Math.random()*max;
    return(m);
  }
  
  /* Copie d'une matrice de reels dans une autre          */
  /* matrice d'entiers                                    */
  
  public static void copieMatrice(float [][] src,float [][] dst) {
    for ( int i = 0 ; i < src.length ; i++ )
      for ( int j = 0 ; j < src[i].length ; j++ )
        dst[i][j] = src[i][j];
  }
  
  /* Produit d'une matrice de reels quelconque            */
  /* par une matrice de reels quelconque avec stockage    */
  /* du resultat dans une 3eme matrice de reels           */
  /* (dimensions des 3 matrices compatibles               */
  /* avec le produit matriciel)                           */
  
  public static void produitMatrices(float [][] m1,float [][] m2,float [][] t) {
    float [][] aux = new float[m1.length][m2[0].length];
    for ( int i = 0 ; i < m1.length ; i++ )
      for ( int j = 0 ; j < m2[0].length ; j++ ) {
        aux[i][j] = 0.0F;
        for ( int k = 0 ; k < m1[0].length ; k++ ) {
          aux[i][j] += m1[i][k]*m2[k][j]; } }
    copieMatrice(aux,t);
  }
  
  /* Calcul de la puissance pieme d'une matrice de reels  */
  /* carree et stockage du resultat dans une 2eme matrice */
  
  public static void puissanceMatrice(float [][] m,int p,float [][] t) {
    float [][] aux = new float[m.length][m.length];
    copieMatrice(m,aux);
    for ( int i = 1 ; i < p ; i++ ) {
      produitMatrices(aux,m,aux); }
    copieMatrice(aux,t);
  }
  
  /* Fonction principale                                  */

  public static void main(String [] args) throws IOException {
    { float [][] mat = matriceAuHasard(4,4,1.0F);
      System.out.println("Matrice mise a la puissance");
      affichageMatrice(mat);
      System.out.println();
      for ( int i = 1 ; i < 10 ; i++ ) {
        System.out.println("Puissance "+i);
        float [][] pm = new float[4][4];
        puissanceMatrice(mat,i,pm);
        affichageMatrice(pm);
        System.out.println(); } }
    { float [][] m =  { { 1.0F,1.0F,1.0F },
                        { 1.0F,1.0F,1.0F },
                        { 1.0F,1.0F,1.0F } };
      System.out.println("Matrice mise a la puissance");
      affichageMatrice(m);
      System.out.println();
      for ( int i = 1 ; i < 6 ; i++ ) {
        float [][] mat =  { { 1.0F,1.0F,1.0F },
                            { 1.0F,1.0F,1.0F },
                            { 1.0F,1.0F,1.0F } };
        System.out.println("Puissance "+i);
        puissanceMatrice(mat,i,mat);
        affichageMatrice(mat);
        System.out.println(); } }
  }
}